--
-- IndoorSound
-- Specialization for IndoorSound
--
-- @author  	Manuel Leithner (SFM-Modding)
-- @version 	v1.0
-- @date  		02/11/11
-- @history:	v1.0 - Initial version
------modifing for open-close door
-- -@ Ago-Systemtech: https://www.facebook.com/ago.systemtech (Modhoster Team)
-- free for noncommerical-usage
--
IndoorSound = {};
function IndoorSound.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Steerable, specializations);
end;
function IndoorSound:load(xmlFile)
	self.indoorSounds = {};
	self.indoorSounds.sounds = {};
	i = 0;
	while true do
		local key = string.format("vehicle.indoorSounds.sound(%d)", i);
		if not hasXMLProperty(xmlFile, key .. "#id") then
			break;
		end;
		local id = getXMLString(xmlFile, key .. "#id");
		local sound = {};
		sound.id = self[id].sample;
		sound.name = id;
		if sound.id == nil then
			break;
		end;
		sound.isDynamic = Utils.getNoNil(getXMLBool(xmlFile, key.."#isDynamic"), false);
		sound.playWhileTreshing = Utils.getNoNil(getXMLBool(xmlFile, key.."#playWhileTreshing"), false);
		sound.outdoor = self[id].volume;
		sound.indoorFactor = Utils.getNoNil(getXMLFloat(xmlFile, key .. "#percent"), 0.5);
		sound.indoor = sound.outdoor * sound.indoorFactor;
		table.insert(self.indoorSounds.sounds, sound);
		i = i + 1;
	end;
	self.indoorSounds.indoorCamIndex = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.indoorSounds#camIndex"), 1);
	self.indoorSounds.lastCamIndex = 0;
	self.volume = 1;
		--by Clod @ TIF-http://forum.tractor-italia.net
	local oSX = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.osx#index"));
    if oSX ~= nil then
        self.osx = {};
        self.osx.node = oSX;
		end;
	local oRX = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.orx#index"));
    if oRX ~= nil then
        self.orx = {};
        self.orx.node = oRX;
		end;
    local tSUP = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.tsup#index"));
    if  tSUP~= nil then
        self.tsup = {};
        self.tsup.node = tSUP;
		end;
	self.intCameraIndex = 1;
	self.dehihoho1=true;
	self.dehihoho2=true;
	self.dehihoho3=true;
	self.p=false;
end;
function IndoorSound:delete()
end;
function IndoorSound:readStream(streamId, connection)
end;
function IndoorSound:writeStream(streamId, connection)
end;
function IndoorSound:mouseEvent(posX, posY, isDown, isUp, button)
end;
function IndoorSound:keyEvent(unicode, sym, modifier, isDown)
end;
function IndoorSound:update(dt)
	if self.isEntered then
		if g_currentMission.driveControl ~= nil and g_currentMission.driveControl.useModules.inDoorSound then
			g_currentMission.driveControl.useModules.inDoorSound = false;
		end;
	end;
	  local x, y, z = getRotation(self.osx.node);
			if y < Utils.degToRad(1) and y > Utils.degToRad(0.01)  then
			self.dehihoho1=true;
			self.soundSwitched=true;
			else
			if y > Utils.degToRad(1) and y < Utils.degToRad(3)  then
			self.dehihoho1=false;
			self.soundSwitched=true;
			end;
			end;
		 local xz, yz, zz = getRotation(self.orx.node);
			if xz < Utils.degToRad(1) and  xz > Utils.degToRad(0.01) then
			self.dehihoho2=true;
			self.soundSwitched=true;
			else
			if xz > Utils.degToRad(1) and xz < Utils.degToRad(3)  then
			self.dehihoho2=false;
			self.soundSwitched=true;
			end;
			end;
		local xt, yt, zt = getRotation(self.tsup.node);
			if xt < Utils.degToRad(1) and  xt > Utils.degToRad(0.01) then
			self.dehihoho3=true;
			self.soundSwitched=true;
			else
			if xt > Utils.degToRad(1) and xt < Utils.degToRad(3)  then
			self.dehihoho3=false;
			self.soundSwitched=true;
			end;
			end;
	if self:getIsActive() and self.isClient then
		   if self.camIndex == self.intCameraIndex and self.dehihoho1 and self.dehihoho2 and self.dehihoho3 then
			if self.volume > 0 then
				self.volume = self.volume - dt/1000;
			else
				self.volume = 0;
			end;
		else
			if self.volume < 1 then
				self.volume = self.volume + dt/1000;
			else
				self.volume = 1;
			end;
	end;
	end;
end;
function IndoorSound:updateTick(dt)
	if self.isEntered then
		if g_currentMission.driveControl ~= nil and g_currentMission.driveControl.useModules.inDoorSound then
			g_currentMission.driveControl.useModules.inDoorSound = false;
		end;
	end;
	if self:getIsActiveForInput(false) then
		local sound = self.indoorSounds;
		if self.isMotorStarted then
			if (self.camIndex == sound.indoorCamIndex ) and self.intCameraIndex and self.dehihoho1 and self.dehihoho2 and self.dehihoho3  then
				for _, sound in pairs(sound.sounds) do
					if not sound.playWhileTreshing then
						if sound.isDynamic then
							self[sound.name].volume = sound.indoor*self.volume;
						else
							setSampleVolume(sound.id, sound.indoor*self.volume);
						end;
					else
						if sound.isDynamic then
							self[sound.name].volume = sound.indoor;
						else
							setSampleVolume(sound.id, sound.indoor);
						end;
					end;
				end;
				sound.lastCamIndex = self.camIndex;
			else
				for _, sound in pairs(sound.sounds) do
					if not sound.playWhileTreshing then
						if sound.isDynamic then
							self[sound.name].volume = sound.outdoor*self.volume;
						else
							setSampleVolume(sound.id, sound.outdoor*self.volume);
						end;
					else
						if sound.isDynamic then
							self[sound.name].volume = sound.outdoor;
						else
							setSampleVolume(sound.id, sound.outdoor);
						end;
					end;
				end;
				sound.lastCamIndex = self.camIndex;
			end;
		end;
	end;
end;
function IndoorSound:draw()
end;